Page MenuHomePhabricator

Allow users to choose their base version for the conflict resolution
Closed, ResolvedPublic

Description

Motivation
Depending on the kind of change it sometimes makes sense to incorporate our changes in the other version or vice versa. Users should be able to select the most sensible starting point.

Task
When the merge screen is opened, the text editor should not yet display any text. Instead, it should have grey bars indicating text and a box that allows users to select their base version for the merge. Clicking "OK" will then fill the text editor with the chosen text.

Please also change the explanatory text of the editor column as described in the mock for js users.
For non-js users, the text stays as it currently is.

Mock

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptApr 4 2017, 1:54 PM
WMDE-Fisch moved this task from Proposed to Todo on the WMDE-QWERTY-Team board.Apr 11 2017, 3:36 PM
Lea_WMDE updated the task description. (Show Details)Apr 12 2017, 2:37 PM
WMDE-Fisch moved this task from Todo to Sprint ready on the WMDE-QWERTY-Team board.

Change 350191 had a related patch set uploaded (by WMDE-Fisch):
[mediawiki/extensions/TwoColConflict@master] [WIP] Add selection dialog for the base version

https://gerrit.wikimedia.org/r/350191

@Lea_WMDE @Jan_Dittrich When the user selects "My text" and the editor then contains his text the description above the editor needs to change.

So what should the user see there?

( currently: )

Initially, the editor's content is the currently published version:
127.0.0.1‎
Add your changes in the editor and click on "publish changes"
Jan_Dittrich added a comment.EditedApr 26 2017, 9:45 AM

So what should the user see there?

@Lea_WMDE @WMDE-Fisch
As far as I know:

If javascript is enabled, and chosing a version thus possible, the text above the editor is at start (as in the mock above)

»
1) Choose the base version in the popup below.
2) Adjust the text to combine both versions.
3) Click on „Publish changes“. Only what is in the editor will be published.
«

Once the user did the selection (that was what you were asking for, if I got it right), the text could stay as it is – it is still valid.
But if we find it confusing, we could gray out and/or checkmark line 1 (or something in that direction)

Ahh... ok it was not really clear to me that in the JS version with base version selection the text stays the same after the selection. Thanks!

Graying out the first step after the selection might be a nice thing though. But this can also be decided later and done in a small follow up.

Patch is now ready to be reviewed. Hint for the reviewers:

Ignore the layout of the left column. On master this does not match the mock (yet) and does not need to. It is unrelated to this ticket.

Change 350191 merged by jenkins-bot:
[mediawiki/extensions/TwoColConflict@master] Add selection dialog for the base version

https://gerrit.wikimedia.org/r/350191

One thing that I noticed here when reviewing the next patch in the chain was that the selection dialogue is positioned right at the top of the input box.

This differs from the mock and I image we will want to add some space there @WMDE-Fisch, @Jan_Dittrich

Yes, we should have some margin because it otherwise looks like it somehow is attached to the toolbar.

Addshore closed this task as Resolved.May 11 2017, 8:50 AM
Tobi_WMDE_SW moved this task from Done to Demoed on the WMDE-QWERTY-Team board.Jun 6 2017, 3:01 PM
Restricted Application added a project: TCB-Team. · View Herald TranscriptJun 6 2017, 3:01 PM